daemon-util.in 3.35 KB
Newer Older
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38
#!/bin/bash
#

# Copyright (C) 2009 Google Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.

set -e

defaults_file=@SYSCONFDIR@/default/ganeti

NODED_ARGS=
MASTERD_ARGS=
CONFD_ARGS=
RAPI_ARGS=

# Read defaults file if it exists
if [[ -s $defaults_file ]]; then
  . $defaults_file
fi

_daemon_pidfile() {
  echo "@LOCALSTATEDIR@/run/ganeti/$1.pid"
}

39 40 41 42 43 44 45 46 47 48 49 50 51 52 53
# Checks whether the local machine is part of a cluster
check_config() {
  local server_pem=@LOCALSTATEDIR@/lib/ganeti/server.pem
  local fname

  for fname in $server_pem; do
    if [[ ! -f $fname ]]; then
      echo "Missing configuration file $fname" >&2
      return 1
    fi
  done

  return 0
}

54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76
# Checks the exit code of a daemon
check_exitcode() {
  if [[ "$#" -lt 1 ]]; then
    echo 'Missing exit code.' >&2
    return 1
  fi

  local rc="$1"; shift

  case "$rc" in
    0) ;;
    11)
      echo "not master"
    ;;
    *)
      echo "exit code $rc"
      return 1
    ;;
  esac

  return 0
}

77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99
# Checks whether daemon is running
check() {
  if [[ "$#" -lt 1 ]]; then
    echo 'Missing daemon name.' >&2
    exit 1
  fi

  local name="$1"; shift

  start-stop-daemon --stop --signal 0 --quiet \
    --pidfile $(_daemon_pidfile $name)
}

# Starts a daemon
start() {
  if [[ "$#" -lt 1 ]]; then
    echo 'Missing daemon name.' >&2
    exit 1
  fi

  local name="$1"; shift

  # Convert daemon name to uppercase after removing "ganeti-" prefix
100
  local ucname=$(echo ${name#ganeti-} | tr a-z A-Z)
101 102

  # Read $<daemon>_ARGS and $EXTRA_<daemon>_ARGS
103
  eval local args="\"\$${ucname}_ARGS \$EXTRA_${ucname}_ARGS\""
104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144

  start-stop-daemon --start --quiet --oknodo \
    --pidfile $(_daemon_pidfile $name) \
    --startas "@PREFIX@/sbin/$name" \
    -- $args "$@"
}

# Stops a daemon
stop() {
  if [[ "$#" -lt 1 ]]; then
    echo 'Missing daemon name.' >&2
    exit 1
  fi

  local name="$1"; shift

  start-stop-daemon --stop --quiet --oknodo --retry 30 \
    --pidfile $(_daemon_pidfile $name)
}

# Starts a daemon if it's not yet running
check_and_start() {
  local name="$1"

  if ! check $name; then
    start $name
  fi
}

# Starts the master role
start_master() {
  start ganeti-masterd
  start ganeti-rapi
}

# Stops the master role
stop_master() {
  stop ganeti-rapi
  stop ganeti-masterd
}

145 146 147 148 149
# Reloads the SSH keys
reload_ssh_keys() {
  @RPL_SSH_INITD_SCRIPT@ restart
}

150 151 152 153 154 155 156
if [[ "$#" -lt 1 ]]; then
  echo "Usage: $0 <action>" >&2
  exit 1
fi

orig_action=$1; shift

157 158 159 160 161
if [[ "$orig_action" == *_* ]]; then
  echo "Command must not contain underscores" >&2
  exit 1
fi

162 163 164 165 166 167 168 169 170 171 172
# Replace all dashes (-) with underlines (_)
action=${orig_action//-/_}

# Is it a known function?
if ! declare -F "$action" >/dev/null 2>&1; then
  echo "Unknown command: $orig_action" >&2
  exit 1
fi

# Call handler function
$action "$@"